using UnityEngine;
using System.Collections;

public class BluesHouseController : MonoBehaviour {
	
	public CameraFollow cameraFollow;
	
	void Awake()
	{
		Application.LoadLevelAdditiveAsync("GameUI");
	}
	
	// Use this for initialization
	IEnumerator Start()
	{
		
		while (GameUI.instance == null) {
			yield return null;
		}
		
		PlayerController player = PlayerController.instance;
		
		if (Game.GetFlag("Intro")) {
			cameraFollow.enabled = true;
			yield break;
		}
		
		player.controlEnabled = false;
		
		yield return StartCoroutine(GameUI.instance.WaitDialog("Use paint to uncover the world around you. But, be careful. Paint is also your Life. It regenerates with time, but if it reaches Zero you die."));
		yield return StartCoroutine(GameUI.instance.WaitDialog("Use WASD keys to move, Space to jump, and the Return/Enter key to paint."));
		
		cameraFollow.enabled = true;
		yield return new WaitForSeconds(1f);
		
		yield return StartCoroutine(player.WaitDialog("Why is everything black?"));
		
		yield return StartCoroutine(player.WaitDialog("Where am i?"));
		
		yield return StartCoroutine(player.WaitDialog("Why don't I remember?"));
		
		player.controlEnabled = true;
		
		Game.SetFlag("Intro");
		
	}
	
	// Update is called once per frame
	void Update()
	{
		
		if (ColorBlock.PercentColored() >= 0.5f) {
			if (!Game.GetFlag("MyHouse?")) {
				Game.SetFlag("MyHouse?");
				StartCoroutine(PlayerController.instance.WaitDialog("I think... I think this is my house."));
			}
		}
		
	}
	
	
}
