using UnityEngine;
using System.Collections;

public class CastleController : MonoBehaviour {
	
	public CameraFollow cameraFollow;
	public ColorBackground background;
	public Transform monochromBattleCameraTarget;
	public GameObject box;
	public Monochrome boss;
	
	public bool triggered = false;
	
	// Use this for initialization
	void Start()
	{
		
		Application.LoadLevelAdditiveAsync("GameUI");
		
		Game.SetFlag("YellowRescued");
		Game.SetFlag("RedRescued");
		Game.SetFlag("PurpleRescued");
		Game.SetFlag("GreenRescued");
		Game.SetFlag("OrangeRescued");
		
		Game.SetFlag("ReachedCastle");
		
	}
	
	void StartMonochromeBattle()
	{
		
		if (triggered) {
			return;
		}
		
		triggered = true;
		
		Game.SetFlag("ReachedMonochrome");
		StartCoroutine(DoMonochromeBattle());
		
	}
	
	IEnumerator DoMonochromeBattle()
	{
		
		PlayerController player = PlayerController.instance;
		
		//Do Some Dialog
		
		cameraFollow.target = monochromBattleCameraTarget;
		box.SetActiveRecursively(true);
		player.controlEnabled = false;
		
		yield return new WaitForSeconds(1.0f);
		
		yield return StartCoroutine(player.WaitDialog("Monochrome!"));
		
		yield return StartCoroutine(boss.WaitDialog("Ho ho ho! So you've finally made it. What's the matter? You look so... \nBlue! hehehe."));
		
		yield return StartCoroutine(player.WaitDialog("What have you done? You've taken all the color and joy from this world!"));
		
		yield return StartCoroutine(boss.WaitDialog("Hah! Are we so forgetful already? It was you who asked for this!"));
		
		yield return StartCoroutine(player.WaitDialog("I would never ask for such a thing!"));
		
		yield return StartCoroutine(boss.WaitDialog("You asked for me to make your \"Blues\" go away and I did just that! All the blue is gone and the others wont bother you anymore."));

		yield return StartCoroutine(player.WaitDialog("No! You've twisted my words! Enough of this!"));
		
		yield return new WaitForSeconds(1.0f);
		
		player.controlEnabled = true;
		boss.behaviorEnabled = true;
		
		//Wait for boss to die
		while (!boss.IsDead) {
			yield return null;
		}
		
		//Need some kind of death explosion effect
		player.controlEnabled = false;
		yield return new WaitForSeconds(1.0f);
		
		yield return StartCoroutine(boss.WaitDialog("You can defeat me, but it won't come back you know! it's too late. The color is all gone!"));
		
		yield return StartCoroutine(player.WaitDialog("Then we'll spend a lifetime painting again..."));
		
		Destroy(boss.gameObject);
		background.SetColor(Color.white);
		yield return new WaitForSeconds(1.0f);
		
		LevelLoader.LoadLevel("TheEnd");
		player.enabled = false;
		
	}
	
}
