using UnityEngine;
using System.Collections;

public class CaveController : MonoBehaviour {
	
	public NpcController purple;
	
	// Use this for initialization
	void Start()
	{
		
		Application.LoadLevelAdditiveAsync("GameUI");
	
		if (Game.GetFlag("PurpleRescued")) {
			Destroy(purple.gameObject);
		}
		
	}
	
	// Update is called once per frame
	void Update()
	{
	
	
	}
	
	public void TalkToPurple()
	{
		if (GameUI.instance.DoingDialog()) {
			return;
		}
		
		StartCoroutine(DoTalkToPurple());
	}
	
	IEnumerator DoTalkToPurple()
	{
		
		
		
		if (!Game.GetFlag("PurpleRescued")) {
		
			PlayerController player = PlayerController.instance;
			player.controlEnabled = false;
			
			yield return StartCoroutine(player.WaitDialog("Purple... you've been trapped too?"));
		
			yield return StartCoroutine(purple.WaitDialog("We all were. I evaded monochrome the longest by hiding in this cave. Finally come to your senses have you?"));
			
			yield return StartCoroutine(player.WaitDialog("What do you mean? I've come to free everyone and set things back as they were."));
			
			yield return StartCoroutine(purple.WaitDialog("Hmm... if you're serious about this then go ahead and take my pigment. You can use it to free Red and destroy the blocks over the Forest entrance."));
			
			player.controlEnabled = true;
			
			Game.SetFlag("PurpleRescued");
			GameUI.instance.UpdateButtons();
		
		} else {
		
			yield return StartCoroutine(purple.WaitDialog("You can use my pigment to destroy the purple seal blocks trapping Red and blocking the entrance to the forest."));
			
		}
		
	}
	
}
