using UnityEngine;
using System.Collections;

public class ForestController : MonoBehaviour {
	
	public NpcController green;
	
	// Use this for initialization
	void Start()
	{
		
		Application.LoadLevelAdditiveAsync("GameUI");
		
		if (Game.GetFlag("GreenRescued")) {
			Destroy(green.gameObject);
		}
		
	}
	
	// Update is called once per frame
	void Update()
	{
	
	
	
	}
	
	public void TalkToGreen()
	{
		
		if (GameUI.instance.DoingDialog()) {
			return;
		}
		
		StartCoroutine(DoTalkToGreen());	
		
	}
	
	public IEnumerator DoTalkToGreen()
	{
		
		PlayerController player = PlayerController.instance;
		
		
		if (!Game.GetFlag("GreenRescued")) {
			
			player.controlEnabled = false;
			
			yield return StartCoroutine(player.WaitDialog("Green..."));
			
			yield return StartCoroutine(green.WaitDialog("It's ok blue... you don't need to say anything... Just don't stop yet. Keep going."));
			
			player.controlEnabled = true;
			
			Game.SetFlag("GreenRescued");
			GameUI.instance.UpdateButtons();
			
		} else {
		
			yield return StartCoroutine(player.WaitDialog("Just don't stop yet. Keep going."));
			
		}
		
	}
	
}
