using UnityEngine;
using System.Collections;

public class MountainController : MonoBehaviour {

	public NpcController orange;
	
	// Use this for initialization
	void Start()
	{
		
		Application.LoadLevelAdditiveAsync("GameUI");
		
		if (Game.GetFlag("OrangeRescued")) {
			Destroy(orange.gameObject);
		}
		
	}
	
	// Update is called once per frame
	void Update()
	{
	
	}

	public void TalkToOrange()
	{
		StartCoroutine(DoTalkToOrange());
	}
	
	IEnumerator DoTalkToOrange()
	{
		
		if (!Game.GetFlag("OrangeRescued")) {
		
			PlayerController player = PlayerController.instance;
			player.controlEnabled = false;
			
			yield return StartCoroutine(player.WaitDialog("Orange"));
			
			yield return StartCoroutine(orange.WaitDialog("Woop Woop!"));
			
			yield return StartCoroutine(player.WaitDialog("??"));
			
			yield return StartCoroutine(orange.WaitDialog("I was just about to reach nirvana when you interrupted..."));
			
			yield return StartCoroutine(player.WaitDialog("I forgot how weird you were..."));
			
			yield return StartCoroutine(orange.WaitDialog("That's what you get. Yessir that's what you get. Word's got around you gave us all up without a sound."));
			
			yield return StartCoroutine(player.WaitDialog("..."));
			
			yield return StartCoroutine(orange.WaitDialog("Looking for a fight? Just a little bit farther now!"));
			
			player.controlEnabled = true;
			
			Game.SetFlag("OrangeRescued");
			GameUI.instance.UpdateButtons();
			
		} else {
			
			yield return StartCoroutine(orange.WaitDialog("Gave us all up without a fight... have a little brown liqour ta' help ya sleep at night."));
			
		}
		
	}
	
}
