using UnityEngine;
using System.Collections;

public class SpectrumSceneController : MonoBehaviour {
	
	public CameraFollow cameraFollow;
	public EnemyController[] chromies;
	public ActionColorBlock towerDoor;
	
	// Use this for initialization
	IEnumerator Start()
	{
		
		Application.LoadLevelAdditiveAsync("GameUI");
		
		while (GameUI.instance == null) {
			yield return null;
		}
		
		if (Game.GetFlag("FirstEnemy")) {
			yield break;
		}
		
		PlayerController player = PlayerController.instance;
		player.controlEnabled = false;
		
		yield return StartCoroutine(player.WaitDialog("Spectral city looks nothing like what it's supposed to... "));
		
		yield return StartCoroutine(player.WaitDialog("and... \nAre those Chromies?! What are they doing here?"));

		chromies[0].AttachCamera();
		
		yield return StartCoroutine(chromies[0].WaitDialog("Hey, hold up a sec. \nIs that a pigment over there?"));
		
		yield return StartCoroutine(chromies[1].WaitDialog("... Yeah! \nDoesn't he know we own this place now?"));
		
		yield return StartCoroutine(chromies[0].WaitDialog("Hahaha, let's teach him a lesson!"));
		
		player.AttachCamera();
		
		yield return StartCoroutine(player.WaitDialog("Uh oh... why do they always have to start trouble?"));
		
		foreach (EnemyController enemy in chromies) {
			enemy.behaviorEnabled = true;
		}
		
		
		player.controlEnabled = true;
		
		Game.SetFlag("FirstEnemy");
		
	}
	
	public void ThatDoorIsYellow()
	{
		StartCoroutine(DoDoorIsYellow());
	}
	
	public IEnumerator DoDoorIsYellow()
	{
		
		PlayerController player = PlayerController.instance;
		
		player.controlEnabled = false;
		yield return StartCoroutine(player.WaitDialog("?? That door..."));
		
		cameraFollow.target = towerDoor.transform;
		yield return new WaitForSeconds(1.5f);
		
		yield return StartCoroutine(player.WaitDialog("It's yellow! Maybe not all the color is gone afterall. I better check it out."));
		
		player.AttachCamera();		
		player.controlEnabled = true;
		
	}
	
	// Update is called once per frame
	void Update () {
	
	}
}
