using UnityEngine;
using System.Collections;

[RequireComponent(typeof(tk2dSprite))]
public class ActionColorBlock : MonoBehaviour {
	
	public static string destinationOnLoad = "";
	
	public bool killPaintParticles = false;
	public bool painted = false;
	
	public GameObject target;
	public string message;
	
	public string text;
	
	public string loadScene;
	public string destination;
	
	tk2dSprite sprite;
	
	void Awake()
	{
		sprite = gameObject.GetComponent<tk2dSprite>();
	}
	
	void Start()
	{
		
		if (!painted) {
			sprite.color = Color.black;
		}
		
	}
	
	void OnCollisionEnter(Collision collision)
	{
		
		if (painted) {
			return;
		}
		
		Particle particle = collision.gameObject.GetComponent<Particle>();
		if (particle != null) {
			
			if (killPaintParticles) {
				particle.Die();	
			}
			
			sprite.color = particle.color;
			painted = true;
			
		}	
		
	}
	
	public void Action()
	{
		
		if (target != null) {
			target.SendMessage(message);
		} else if (text != "") {
			
			NpcController npc = gameObject.GetComponent<NpcController>();
			
			if (GameUI.instance.DoingDialog()) {
				return;
			}
			
			if (npc == null) {
				GameUI.instance.Dialog(text);
			} else {
				StartCoroutine(npc.WaitDialog(text));
			}
			
		} else if (loadScene != "") {
			destinationOnLoad = destination;
			LevelLoader.LoadLevel(loadScene);
		}
		
	}
	
}
