using UnityEngine;
using System.Collections;

public class CameraFollow : MonoBehaviour {
	
	public Transform target;
	
	public bool clamp = true;
	public Vector2 min;
	public Vector2 max;
	public float dampTime = 0.5f;
	
	private Vector3 dampPosition = Vector3.zero;
	private Vector3 velocity = Vector3.zero;
	private float targetZ = 0;
	
	// Use this for initialization
	void Start()
	{
		targetZ = this.transform.position.z;
	}
	
	void FixedUpdate()
	{
		//LazyFollow();
	}
	
	void LateUpdate()
	{
		
		if (target == null) {
			return;
		}
		
		LazyFollow();
	}
	
	public void LazyFollow()
	{
		//Get Target Position in the X,Y plane
		Vector3 targetPosition = target.position;
		targetPosition.z = targetZ;
			
		dampPosition = Vector3.SmoothDamp(dampPosition, targetPosition, ref velocity, dampTime); 
		
		Vector3 newPosition = dampPosition;
		
		if (clamp) {
			//Clamp to view rect
			newPosition.x = Mathf.Clamp(newPosition.x, min.x, max.x);
			newPosition.y = Mathf.Clamp(newPosition.y, min.y, max.y);
		}
		
		this.transform.position = newPosition;
		//rigidbody.MovePosition(newPosition);		
	}
	
}
