using UnityEngine;
using System.Collections;

public class ColorBackground : MonoBehaviour {
	
	tk2dSprite sprite;
	
	Color currentColor = Color.white;
	Color targetColor = Color.white;
	
	public Color blue = Color.blue;
	public Color red = Color.red;
	public Color yellow = Color.yellow;
	public Color purple = Color.blue;
	public Color green = Color.green;
	public Color orange = Color.yellow;
	
	float timer = 0f;
	
	// Use this for initialization
	void Start()
	{
		
		sprite = gameObject.GetComponent<tk2dSprite>();
	
	}
	
	public void SetColor(Color color)
	{
		
		targetColor = color;
		timer = 1.0f;
		
	}
	
	public void SetColor(PlayerColor pColor)
	{
		SetColor(GetColor(pColor));
	}
	
	
	// Update is called once per frame
	void Update()
	{
	
		if (timer > 0) {
		
			timer = Mathf.Clamp01(timer - Time.deltaTime);
			
			sprite.color = Color.Lerp(currentColor, targetColor, 1.0f - timer);
		
			if (timer <= 0) {
				currentColor = targetColor;
			}
		
		}
		
	}
	
	public Color GetColor(PlayerColor pColor)
	{
		
		switch (pColor) {
		case PlayerColor.Blue:
			return blue;
		case PlayerColor.Red:
			return red;
		case PlayerColor.Yellow:
			return yellow;
		case PlayerColor.Green:
			return green;
		case PlayerColor.Purple:
			return purple;
		case PlayerColor.Orange:
			return orange;
		default:
			return Color.white;
		}
		
	}
	
}
