using UnityEngine;
using System.Collections;

[RequireComponent(typeof(tk2dSprite))]
public class ColorBlock : MonoBehaviour {
	
	static float totalBlocks = 0f;
	static float coloredBlocks = 0f;
	
	public bool killPaintParticles = true;
	
	public static float PercentColored()
	{
		if (totalBlocks <= 0) {
			return 1f;
		}
		
		return coloredBlocks / totalBlocks;
		
	}
	
	tk2dSprite sprite;
	float dampFactor = 0.8f;
	int count = 0;
	
	void Awake()
	{
		sprite = gameObject.GetComponent<tk2dSprite>();
		totalBlocks += 1;
	}
	
	void OnDestroy()
	{
		
		totalBlocks -= 1;
		
		if (count == 2) {
			coloredBlocks -= 1;
		}
		
	}
	
	// Use this for initialization
	void Start()
	{
		sprite.color = Color.black;
	}
	
	// Update is called once per frame
	void Update()
	{
	
	}
	
	void OnCollisionEnter(Collision collision)
	{
		if (count >= 2) {
			return;
		}
		
		Particle particle = collision.gameObject.GetComponent<Particle>();
		if (particle != null) {
			
			if ( killPaintParticles ) {
				particle.Die();	
			}
			
			Color color = sprite.color;
			color.r = Mathf.Clamp01(color.r + (particle.color.r - color.r) * dampFactor);
			color.g = Mathf.Clamp01(color.g + (particle.color.g - color.r) * dampFactor);
			color.b = Mathf.Clamp01(color.b + (particle.color.b - color.r) * dampFactor);
			sprite.color = color;
			
			if (count < 2) { 
				count += 1;
				if (count == 2) {
					coloredBlocks += 1;
				}
			}
			
		}	
		
	}
	
}
