using UnityEngine;
using System.Collections;

public class TurretChromie : EnemyController {
	
	public Projectile projectilePrefab;
	
	private float attackCooldown = 0f;
	
	public void Update()
	{
		
		CheckImmunity();
		CheckPhysics();
		
		if (behaviorEnabled) {
			if (alwaysActive || renderer.isVisible) {
				CheckDirection();
			}
		}
				
		SnapToGrid();
		
		if (attackCooldown < 0) {
			Attack();
		} else {
			attackCooldown -= Time.deltaTime;
		}
		
	}
	
	void Attack()
	{
		
		if (YDistanceToPlayer() > 32f) {
			return;
		}
		
		//Attack speed is in attacks per second
		attackCooldown = 1f / stats.attackSpeed;
		
		Projectile projectile = Instantiate(projectilePrefab, transform.position + Vector3.up * 8, Quaternion.identity) as Projectile;
		projectile.direction = new Vector3(direction, 0, 0);
		
	}
	
	public float YDistanceToPlayer()
	{
		return Mathf.Abs(transform.position.y - PlayerController.instance.y);
	}
	
}
