using UnityEngine;
using System.Collections;

public class EventTrigger : MonoBehaviour {
	
	public GameObject target;
	public string message;
	public string text;
	public string loadScene;
	public string destination;
	
	public bool triggerOnlyOnce = false;
	public string flag = "";
	public string setFlag = "";
	
	// Use this for initialization
	void Start()
	{
	
	}
	
	void OnTriggerEnter(Collider other)
	{
		
		if (other.gameObject == PlayerController.instance.gameObject) {
			Trigger();
		}
		
	}
	
	public void Trigger()
	{
		
		if (triggerOnlyOnce && Game.GetFlag(flag)) {
			return;
		}
		
		if (target != null) {
			target.SendMessage(message);
		} else if (text != "") {
			GameUI.instance.Dialog(text);
		} else if (loadScene != "") {
			ActionColorBlock.destinationOnLoad = destination;
			LevelLoader.LoadLevel(loadScene);
		}
		
		if (setFlag != "") {
			Game.SetFlag(setFlag);
		}
		
	}
	
}
