using UnityEngine;
using System.Collections;

public class PaintBlock : MonoBehaviour {
	
	public bool killPaintParticles = true;
	public bool painted = false;
	
	public enum PaintBlockColor {
		BLUE,
		RED,
		YELLOW,
		ORANGE,
		GREEN,
		PURPLE
	}
	
	public PaintBlockColor blockColor;
	
	void Awake()
	{
	}
	
	void Start()
	{
		
	}
	
	Color GetColor()
	{
		
		switch (blockColor) {
			
		case PaintBlockColor.BLUE:
			return Game.blue;
		case PaintBlockColor.RED:
			return Game.red;
		case PaintBlockColor.YELLOW:
			return Game.yellow;
		case PaintBlockColor.ORANGE:
			return Game.orange;
		case PaintBlockColor.GREEN:
			return Game.green;
		case PaintBlockColor.PURPLE:
			return Game.purple;
		
		default:
			return Game.blue;
			
		}
		
	}
	
	void OnCollisionEnter(Collision collision)
	{
		
		if (painted) {
			return;
		}
		
		Particle particle = collision.gameObject.GetComponent<Particle>();
		if (particle != null) {
			
			if (killPaintParticles) {
				particle.Die();	
			}
			
			if (particle.color == GetColor()) {
				Destroy(gameObject);
			}
			
		}	
		
	}
	
}
